/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.decoder;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.x86.op.MOV_RSEGR16;
import ru.ispras.microtesk.model.x86.mode.RSEG16;
import ru.ispras.microtesk.model.x86.mode.GPR16;

/**
 * The {@code DecoderMOV_RSEGR16} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderMOV_RSEGR16 extends DecoderItem {
  private static DecoderMOV_RSEGR16 instance = null;

  public static DecoderMOV_RSEGR16 get() {
    if (null == instance) {
      instance = new DecoderMOV_RSEGR16();
    }
    return instance;
  }

  private DecoderMOV_RSEGR16() {
    super(
        17,
        false,
        null,
        null
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    RSEG16 dst = null;
    GPR16 src = null;

    if (!matchNextOpc(image, BitVector.valueOf("10001110110", 2, 11))) {
      return null;
    }

    dst = (RSEG16) readNextPrimitive(image, DecoderRSEG16.get());
    if (null == dst) {
      return null;
    }

    src = (GPR16) readNextPrimitive(image, DecoderGPR16.get());
    if (null == src) {
      return null;
    }

    return newResult(new MOV_RSEGR16(dst, src));
  }
}
